function SMdq1_skalar_P
%function SMdq1_skalar_P
%Lsd  - Stnderinduktivitt Lngsachse / stator inductance d-axis    // [H]
%Lsq  - Stnderinduktivitt Querachse  / stator inductance q-axis    // [H]
%Rs   - Stnderwiderstand              / stator resistance           // [Ohm]
%PsiP - Polradfluss                    / field-linked d-axis flux    // [Vs]
%zp   - Polpaaranzahl                  / pole pair number            // [-]
%JM   - Trgheitsmoment Motor          / inertia torque motor side   //[Kgm^2/rad]
%Kd   - Omega-proportionale Reibung    / omega proportional friction //[Nms/rad]

assignin('base','Lsd',0.00163); % [H]
assignin('base','Lsq',0.0017);  % [H]
assignin('base','Rs',0.13);     % [Ohm]
assignin('base','PsiP',1.52);   % [Vs]
assignin('base','zp',1);        % [-]
assignin('base','JM',0.021);    % [Kgm^2/rad]
assignin('base','Kd',0.2);      % [Nms/rad]

txt1='Parameter fr Bondgraph SM Beispiel 1 skalar geladen!';
txt2='Parameter loaded - bond graph example 1 SMdq scalar';
disp([txt1 sprintf('\n') txt2]);
