function Hubmagnet_S63_P
%function Hubmagnet_S63_P
%n  -   Windungszahl              / coil: number of turns       // [-]
%my0-   Magnetische Feldkonstante / magnetic field coefficient  // [Vs/(Am)]
%myr-   Permeabilitt von Eisen   / permeability iron           // [-]
%l1 -   mittlere Weglnge der Feldlinien im Eisen /
%                 line of magnetic flux: medial length in iron  // [m]
%R  -   Ohmscher Widerstand Spule  / coil: resistor             // [Ohm]
%A  -   Schenkelquerschnitt        / cross section of the limb  // [m^2]
%m  -   Ankermasse                 / armature mass              // [kg]
%g  -   Erdbeschleunigung          / gravity coefficient        // [m/s^2]
%x0 -   Anfangslage des Ankers     / armature: initial position // [m]
%u  -   Spannung                   / voltage                    // [V]

assignin('base','n',1200);       % [-]
assignin('base','my0',1.256e-6); % [Vs/(Am)]
assignin('base','myr',65);       % [-]
assignin('base','l1',0.15);      % [m]
assignin('base','R',6.5);        % [Ohm=V/A]
assignin('base','A',9e-4);       % [m^2]
assignin('base','m',0.35);       % [kg]
assignin('base','g',9.81);       % [m/s^2]
assignin('base','x0',-0.01);     % [m]
assignin('base','u',10);         % [V]

txt1='Parameter fr Bondgraph Beispiel Hubmagnet (Scherf 6.3) geladen!';
txt2='Parameter loaded - bond graph example lift magnet (Scherf 6.3)';
disp([txt1 sprintf('\n') txt2]);