function TwoaxisGimbal_P
%See: "Bond Graph Approach to the Modeling and Simulation of a Two-Axis
%                                          Pointing and Tracking System"
%Sheng D., Fan D., Luo H., Nie X.; Proc. of the 2007 IEEE
%International Conference on Mechatronics and Automation, pp. 2337-2339

assignin('base','Ji_x',0.0070);   %Inertia Ji_x [Kgm^2/rad]
assignin('base','Ji_y',0.0055);   %Inertia Ji_y [Kgm^2/rad]
assignin('base','Ji_z',0.0034);   %Inertia Ji_z [Kgm^2/rad]
assignin('base','Jo_z',0.0075);   %Inertia Jo_z [Kgm^2/rad]
assignin('base','fric_a',0.1);    %Friction a [Nms/rad]
assignin('base','fric_e',0.1);    %Friction e [Nms/rad]

txt='"TwoaxisGimbal"';
disp(['Parameter for Bond Graph example ' txt ' loaded!']);
