function BGV2_ABT
%AB-Activated bond: Umschaltung zwischen E-activated und F-activated
%Der entsprechende Kode wird in der Block-Initialisierung [BGV2_Init(90)] gesetzt

h=gcb;
TY=get_param(h,'TY');
TY1=TY(1);
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','BlockType','Inport');
N=find_system(blks,'name',TY1);
if  isempty(N)    %Einstellung ndern
    if   TY1=='F' %Zieleinstellung ist 'F'
         set_param([h '/e'],'name','f');
         set_param([h '/E'],'name','Ea');
         set_param([h '/F'],'name','E');
         set_param([h '/Ea'],'name','F');
    else          %Zieleinstellung ist 'E'
         set_param([h '/f'],'name','e');
         set_param([h '/F'],'name','Fa');
         set_param([h '/E'],'name','F');
         set_param([h '/Fa'],'name','E');
    end
end
