function BGV2_EA_AU(Schalter,Blockname,EAS)
%Wahlweise Freigabe / Sperre eines Ausgangs
% Schalter  - Parameter im MaskenEditor
% Blockname - Name des Ausgangsblockes in SIMULINK
% EAS       - Name eines "Constant Blocks" als Enable Schalter fr ein Subsystem

h=gcb;
if strcmp(get_param(h,Schalter),'on')   %Ausgang freigeben
   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                              'BlockType','Outport');
   N=find_system(blks,'name',Blockname);%Freigabe schon eingestellt?
   if  isempty(N)                       %Einstellung ndern
       replace_block(h,'FollowLinks','on','name',Blockname,...
                                                       'built-in/Outport','noprompt')
       set_param([h '/' EAS],'Value','1');%Subsystem zur Ausgangsberechnung freigeben
   end
else                                    %Ausgang sperren
   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                           'BlockType','Terminator');
   N=find_system(blks,'name',Blockname);%Sperre schon eingestellt?
   if  isempty(N)                       %Einstellung ndern
       replace_block(h,'FollowLinks','on','name',Blockname,...
                                                    'built-in/Terminator','noprompt')
       set_param([h '/' EAS],'Value','0');%Subsystem zur Ausgangsberechnung sperren
   end
end
