function BGV2_ICF
%ICF-Element: Umschaltung zwischen E-, F- und Mixed-causal
%Der Kode wird in der Block-Initialisierung [BGV2_Init(80,...)] gesetzt
%Ein- / Ausgnge ber Schleifenzhler gesetzt wie fr Knoten

FT01='-Element';
FT02='False dimension of InputDimensionVector ! ';
FT03='False elements of InputDimensionVector ! ';
FT04='False dimension of InputDimensionMatrix ! ';
FT05='False elements of InputDimensionMatrix ! ';
FT06='False zeros in InputDimensionMatrix !';

FT10='BGV2_ICF: AttributesFormatString fault!';
FT11='Fatal error - Unexpected switch code';
FT12='BGV2_ICF - Momentum / Displacement output names';
FT13='BGV2_ICF - Arithmetic Mode';

h=gcb;
TYW=get_param(h,'TY');
if     findstr(TYW,'IF-'),            ICF=1; else ICF=0; end; %Alternative: CF-
if     findstr(TYW,'Integral'),       IDM=1; 
elseif findstr(TYW,'Differential'),   IDM=0; else IDM=2; end; %Alternative: Mixed
bln=get_param(h,'Name'); %Blockname des Subsystems, siehe auch BGV2_KNZ.m
h2=gcs;
Tag=get_param(h,'AttributesFormatString');
if isempty(Tag), Tag1=0; elseif Tag==' ', Tag1=1; else error(FT10); end %Merkerabf.
Tag2=(ICF&IDM==1)|(~ICF&IDM==0);   %Momentum- und Displacement-Ausgnge wie default
if   Tag2, set_param(h,'AttributesFormatString',' ');
else      set_param(h,'AttributesFormatString','');  end         %Merker neu setzen

if   IDM~=2                                         %Flow/Effort causal!
     Anz=str2num(get_param(h,'Anz1')); set=[1 2 3 4 5 6 7 8 9]; [ii,jj]=size(Anz);
     if     ~isvector(Anz)                          %Dimensionen eines Vektors?
            errordlg([h 10 10 FT02],['ICF' FT01]); return %Prfung 2-stufig!
     elseif sum(ismember(Anz, set))~=jj             %Elemente des Vektors zulssig?
            errordlg([h 10 10 FT03],['ICF' FT01]); return;
     end
     if     Tag2,      x_neu=0;           y_neu=length(Anz); z_neu=y_neu; %E-causal
     else              x_neu=length(Anz); y_neu=0;           z_neu=x_neu; end
     v=[sum(Anz)-1 1];                     %willkrliche Teilung: Aktion ntig, da 
     DeMuIO=['[' num2str(v) ']'];          %nicht feigegebenes SS auch geprft wird
     set_param([h '/Mix/MEV'], 'Outputs', DeMuIO); %DEM/MUX von Mix mssen richtige
     set_param([h '/Mix/MAV'], 'Inputs',  DeMuIO); %Anzahl Elemente haben!
else                                                     %Mixed causal!
     Anz=str2num(get_param(h,'Anz2')); set=[0 1 2 3 4 5 6 7 8 9];[ii,jj]=size(Anz);
     if     isempty(Anz) || ii~=2 %Falscheingabe --> str2num --> empty:Matrix-Dim.?
            errordlg([h 10 10 FT04],['ICF' FT01]); return %Prfung 2-stufig!
     elseif sum(sum(ismember(Anz, set)))~=ii*jj    %Elemente des Vektors zulssig?
            errordlg([h 10 10 FT05],['ICF' FT01]); return;
     end
     F10=find(Anz(1,:)==0); if isempty(F10), F10=jj; end %Pos. von Nullen in F_vec
     F20=find(Anz(2,:)==0); if isempty(F20), F20=jj; end %Pos. von Nullen in E_vec
     F11=find(Anz(1,:));    if isempty(F11), F11=jj; end %Pos. von Nicht-Nullen
     F21=find(Anz(2,:));    if isempty(F21), F21=jj; end %Pos. von Nicht-Nullen
     if max(F11)>min(F10) || max(F21)>min(F20) || ...  %Falsche Null in Eingngen?
        (Anz(1,end)==0 && Anz(2,end)==0)            %Doppelte End-Null?
        errordlg([h 10 10 FT06],['ICF' FT01]); return;
     end
     AnzM=str2num(get_param(h,'Anz2'));        %Werte fr "Mixed causal" setzen
                         v=sum(AnzM&1,2);      %&1:NullElem.erkennen/,2:Zeilensumme
                         x_neu=v(1);        y_neu=v(2);       z_neu=x_neu+y_neu;
     %Matrix: Eingabe umformen --> Spalten lesen + Vektor bilden / Null ausblenden
     M1=AnzM'; M2=M1(1:end); Anz=M2(logical(M2&M2));
end

MuDeIO=['[' num2str(Anz) ']']; %set_param fr Mux/Dem bentigt String mit '[ ... ]'
blks=find_system(h,'SearchDepth',1,'FollowLinks','on','LookUnderMasks','all',...
                                                      'BlockType','Inport');
z_alt=length(blks);              

NL=find_system(blks,'name','NL');         %Eingnge NL und NL2 vorhanden?
Delta=0;                                  %Merker
if  ~isempty(NL), z_alt=z_alt-2;          %Gesamt-Ist-Anzahl der Feldeingnge
    Delta=1;                              %Merker setzen
end

NF=find_system(blks,'name','F1'); 
NE=find_system(blks,'name','E1');
if      ~isempty(NF)&& ~isempty(NE) 
        y=str2num(get_param([h '/E1'],'Port'));  %Anzahl F / E unterscheiden
                                      x_alt=y-1;         y_alt=z_alt-x_alt;
elseif  isempty(NE),                  x_alt=z_alt;       y_alt=0;
else                                  x_alt=0;           y_alt=z_alt;
end

if z_neu>z_alt %MUX/DEM - Einstellung hier >>nur Erweiterung<< - vor line einfgen
   set_param([h '/EV'], 'Inputs', MuDeIO);   %MUX: setzen mit Anz als String
   set_param([h '/AV'], 'Outputs', MuDeIO);  %DEM
end
for j=z_neu+1:z_alt       %Restliche Inport und Goto sowie Verbindungen lschen
    Nr=num2str(j);        %Nummer fr F- /E-Namen und Goto-Ports bleibt erhalten
    if   j<=x_alt         % Inport:: alter Name "F..." ? ja: ---> F_Nummer==j
         N='F'; NrI=Nr; 
    else                  % Inport:: alter Name "E..." !
         N='E'; NrI=num2str(j-x_alt);
    end
    delete_line([h2 '/' bln],['AV/' Nr],['I' Nr '/1']);
    delete_block([h '/I' Nr]);
    delete_line([h2 '/' bln],[N NrI '/1'],['EV/' Nr]);
    delete_block([h '/' N NrI]);
end
if z_neu<=z_alt %MUX/DEM - Einstellung hier >>>nur Krzung<<< - erst line lschen!
   set_param([h '/EV'], 'Inputs', MuDeIO);  %MUX: setzen mit Anz als String
   set_param([h '/AV'], 'Outputs', MuDeIO); %DEM
end

j=0;             %Vorbereitung ENralt
for i=1:x_neu        %F-Eingnge
    Nr=num2str(i);   %InportNummer
    if     i<=x_alt  %nicht mehr F-Eingnge als vorher F-Eingnge ---> keine Aktion
    elseif i<=z_alt  %mehr F-Eingnge, aber nicht mehr als vorher insgesamt
           j=j+1; ENralt=num2str(j);
           set_param([h '/E' ENralt],'name',['F' Nr]);%"E" in "F" + neue Nr. ndern
    else             %mehr F-Eingnge als vorher insgesamt
                     add_block('built-in/Inport',[h '/F' Nr],'Port',Nr);
                     add_line([h2 '/' bln],['F' Nr '/1'],['EV/' Nr]);
       L=length(h); Pfad=h; for j=1:L, if Pfad(j)==47, Pfad(j)=95; end;end%'/'->'_'
       N=[ Pfad Nr];
       add_block('built-in/Goto',[h '/I' Nr],'GotoTag',N,'TagVisibility','global');
       add_line([h2 '/' bln],['AV/' Nr],['I' Nr '/1']);
    end
end
if z_neu>=z_alt, jr=y_alt; else jr=y_alt-(z_alt-z_neu); end%Vorb. ENralt: rckwrts
jv=1+x_neu-x_alt;                                          %Vorb. ENralt: vorwrts
for ii=x_neu+1:z_neu %E-Eingnge
                     %F=konstant: 1 und 5 gengen, da entfernen vorher erfolgt
    if x_neu<x_alt, i=z_neu+x_neu+1-ii;R=1; else i=ii;R=0; end %E-Eingge rckwrts?
    Nr=num2str(i);   %InportNummer
    ENrneu=num2str(i-x_neu);
    if     i<=z_alt && x_alt==x_neu %keine Aktion, da nur mehr E-Eingnge
    elseif i<=x_alt  %Umbenennen F ---> E: weniger F-Eingnge als vorher F-Eingnge
           set_param([h '/F' Nr],'name',['E' ENrneu]); %"F" in "E" ndern
    elseif i<=z_alt && R  %Umbenennen E --> E rckwrts / nur ENr.
           ENralt=num2str(jr);
           set_param([h '/E' ENralt],'name',['E' ENrneu]);
           jr=jr-1;
    elseif i<=z_alt && ~R %Umbenennen E --> E vorwrts / nur ENr.
           ENralt=num2str(jv);
           set_param([h '/E' ENralt],'name',['E' ENrneu]);
           jv=jv+1;
    else                  %mehr Eingnge als vorher insgesamt
           add_block('built-in/Inport',[h '/E' ENrneu],'Port',Nr);
           add_line([h2 '/' bln],['E' ENrneu '/1'],['EV/' Nr]);
       L=length(h); Pfad=h; for j=1:L, if Pfad(j)==47, Pfad(j)=95; end;end%'/'->'_'
       N=[ Pfad Nr];
       add_block('built-in/Goto',[h '/I' Nr],'GotoTag',N,'TagVisibility','global');
       add_line([h2 '/' bln],['AV/' Nr],['I' Nr '/1']);
    end
end

if  Delta==1                        %NL und NL2 Merker
    Nr=num2str(z_neu+1);            %erst am Ende,denn:
    set_param([h '/NL'],'Port',Nr); %NL-Port-Nr kann PortNr. von E1 verflschen
    Nr=num2str(z_neu+2);            %NL2 wie NL behandeln
    set_param([h '/NL2'],'Port',Nr);
end
%   ------------------- Bis hier Algorithmus von RF -----------------------

if IDM==2,                     x0=1; else x0=0; end  %Jetzt  mixed eingestellt ?
if ~isempty(NF)&&~isempty(NE), x1=2; else x1=0; end  %Vorher mixed eingestellt ?
if Tag1~=Tag2,                 x2=4; else x2=0; end  %Liegt Wechsel Feldtyp vor?
t=x0+x1+x2;
FSW=0;             %FreigabeSchalterWechsel == Namenstausch in SIMULINK
switch t           %Bezeichnung der Momentum- / Displacement-Ausgnge
    case {0,3,7}   %Keine Aktion 
    case {1,5},    if Tag1, set_param([h '/M'],'name','D_M');
                            set_param([h '/D'],'name','M_D'); FSW=1;
                   else     set_param([h '/M'],'name','M_D');
                            set_param([h '/D'],'name','D_M');
                   end
    case {2,6},    if Tag2, set_param([h '/M_D'],'name','D');
                            set_param([h '/D_M'],'name','M'); FSW=1;
                   else     set_param([h '/M_D'],'name','M');
                            set_param([h '/D_M'],'name','D');
                   end
    case {4}       %Ausgnge Momentum / Displacement berkreuz umbenennen - wie ICT
                   set_param([h '/M'],'name','U');
                   set_param([h '/D'],'name','M');
                   set_param([h '/U'],'name','D'); FSW=1;
    otherwise, errordlg(FT11,FT12); return;
end
if FSW,  set_param([h '/SM'],'name','SU');
         set_param([h '/SD'],'name','SM'); set_param([h '/SU'],'name','SD'); end
switch IDM                       %Einstellung der Arithmetik mit Schaltern
    case {1}, S1=1; S2=[1 0 0];  %Intergration freigeben
    case {0}, S1=2; S2=[0 1 0];  %Differentation freigeben
    case {2}, S1=3; S2=[0 0 1];  %Mixed freigeben
              v=sum(AnzM,2);     %ElementeAnzahlSummen fr F und E bilden
              DeMuIO=['[' num2str(v') ']']; %set_param: String mit '[ ... ]' ntig
              set_param([h '/Mix/MEV'], 'Outputs', DeMuIO);%DEM: Elementesummen F/E
              set_param([h '/Mix/MAV'], 'Inputs',  DeMuIO);%MUX: von Anz2 Zei1/Zei2
              if ICF             % I-Feld ?
                 replace_block([h '/Mix'],'FollowLinks','on','name','AR1',...
                                                 'built-in/Derivative','noprompt');
                 replace_block([h '/Mix'],'FollowLinks','on','name','AR2',...
                                                 'built-in/Integrator','noprompt');
              else               % nein C-Feld
                 replace_block([h '/Mix'],'FollowLinks','on','name','AR1',...
                                                 'built-in/Integrator','noprompt');
                 replace_block([h '/Mix'],'FollowLinks','on','name','AR2',...
                                                 'built-in/Derivative','noprompt');
              end
    otherwise, errordlg(FT11,FT13); return;
end
SV1=num2str(S1); SV2=['[' num2str(S2) ']'];%geschachtelt nicht mglich!
set_param([h '/S1'],'Value',SV1);        %Ausgang eines arithmetischen SS auswhlen
set_param([h '/S2'],'Value',SV2);        %dieses arithmetische Subsystem freigeben
