function BGV2_ICT
%Erweiterungsbibliothek Bondgraph V.2 // I/C - Speicher: Typ-Erkennung
%                                        I-Speicher / C-Speicher
%                                        Integrale / Differenzielle Kausalitt
%Der entsprechende Kode wird in der Blockinitialisierung gesetzt
%Umgestellt von Tag auf AttributesFormatString als Merker

FT00='BGV2_ICT';
FT01='AttributesFormatString fault!';
FT02a='Setting "Reset integrator / DM limitation" cancelled!';
FT02b='Allowed only for Mode:"Scalar" & Type:"Integral causality".';

h=gcb; TYW=get_param(h,'TY');
if findstr(TYW,'I-')       IC=1; else IC=0; end;            %Alternative: Destination
if findstr(TYW,'Integral') ID=1; else ID=0; end;            %Alternative: Flow

blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','BlockType','Inport');

Tag=get_param(h,'AttributesFormatString');
if     isempty(Tag) Tag1=0;                                        %Merkerabfrage
elseif Tag==' '     Tag1=1;
else   errordlg([h 10 10 FT01],FT00); return;
end
Tag2=(IC&ID)|(~IC&~ID);   %Momentum- und Displacement-Ausgnge wie default bezeichnen
if   Tag2 set_param(h,'AttributesFormatString',' ');
else      set_param(h,'AttributesFormatString','');  end           %Merker neu setzen

if Tag2                          %I-Speicher/integral  ODER  C-Speicher/differentiell
   N=find_system(blks,'name','E');                                   %Eingangsname?
   if isempty(N) 
      set_param([h '/F'],'name','U');
      set_param([h '/E'],'name','F');                                %Ausgangsname
      set_param([h '/U'],'name','E');                                %Eingangsname
   end
else                             %I-Speicher/differentiell  ODER  C-Speicher/integral
   N=find_system(blks,'name','F');                                   %Eingangsname
   if isempty(N) 
      set_param([h '/E'],'name','U');
      set_param([h '/F'],'name','E');                                %Ausgangsname
      set_param([h '/U'],'name','F');                                %Eingangsname
   end
end

load_system('BG_V20_TS');    %invisible load (auch nicht in Bereitschaftsleiste!)
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                      'BlockType','SubSystem');  %ntig bei ffnung des Maskenmens
RB=get_param(h,'RB');
MU=get_param(h,'MU');
if (IC&ID)|(~IC&ID)                   %I-Speicher/integral  ODER  C-Speicher/integral
   if findstr(MU,'Scalar')&strcmp(RB,'on') %Rchsetzbarer Int / Begrenzung DM mglich
     if isempty(find_system(blks,'name','RI_I')) %schon eingestellt ?
        replace_block(h,'FollowLinks','on','name','I_I','BG_V20_TS/RI_I','noprompt');
        set_param([h '/I_I'],'name','RI_I');
       replace_block(h,'FollowLinks','on','name','I_D','BG_V20_TS/BI_DM','noprompt');
        set_param([h '/I_D'],'name','BI_DM');
     end
   elseif strcmp(RB,'off')                 %
       if isempty(find_system(blks,'name','I_I')) %vorher Rcksetzbarer Integrator?
                                              % --> Name und Inhalt falsch!
        replace_block(h,'FollowLinks','on','name','RI_I','BG_V20_TS/I_I','noprompt');
          set_param([h '/RI_I'],'name','I_I');
       replace_block(h,'FollowLinks','on','name','BI_DM','BG_V20_TS/I_D','noprompt');
          set_param([h '/BI_DM'],'name','I_D');
       else    %vorher Einfachvar./Name richtig;I_D existiert schon/I_I berschreiben
         replace_block(h,'FollowLinks','on','name','I_I','BG_V20_TS/I_I','noprompt');
       end   
   else errordlg([h 10 10 FT02a 10 FT02b],FT00);
        set_param(h,'RB','off'); return;
   end
else                        %I-Speicher/differentiell  ODER  C-Speicher/differentiell
   if strcmp(RB,'on') errordlg([h 10 10 FT02a 10 FT02b],FT00);
                      set_param(h,'RB','off'), return; end
   if isempty(find_system(blks,'name','I_I')) %vorher Rcksetzbarer Integrator?
                                              % --> Name und Inhalt falsch!
      replace_block(h,'FollowLinks','on','name','RI_I','BG_V20_TS/I_Dif','noprompt');
      set_param([h '/RI_I'],'name','I_I');
      replace_block(h,'FollowLinks','on','name','BI_DM','BG_V20_TS/I_D','noprompt');
      set_param([h '/BI_DM'],'name','I_D');
   else        %vorher Einfachvar./Name richtig;I_D existiert schon/I_I berschreiben
      replace_block(h,'FollowLinks','on','name','I_I','BG_V20_TS/I_Dif','noprompt');
   end
end

if Tag1~=Tag2 %Ausgnge/Freigabeschalter Momentum / Displacement berkreuz umbenennen
   set_param([h '/M'],'name','U');  set_param([h '/SM'],'name','SU');
   set_param([h '/D'],'name','M');  set_param([h '/SD'],'name','SM');
   set_param([h '/U'],'name','D');  set_param([h '/SU'],'name','SD');
end

MV=get_param(h,'MaskVisibilities');    %Einstellung von EA_PA ergnzen
if strcmp(RB,'on')                     %Jetzt zulssige Einstellung von RB bekannt
   for i=9:12 MV{i}='on'; end          %Sonderfall RB zuschalten
else
   for i=9:12 MV{i}='off'; end         %Sonderfall RB abschalten
end

AWS=strcmp(get_param(h,'AWS'),'on');
if AWS, MV{14}='on'; else MV{14}='off';end %Anfangswert(Integrator) E/F 
set_param(h,'MaskVisibilities',MV);
