function BGV2_KNA
%Erweiterungsbibliothek Bondgeaph V.2 // KN - Element: Abgefhrte Energie
%                                                      Portanzahl AB >= 0

FT00='KN Element - BGV2_KNA';
FT01='No execution: False "CPP" Input!';
FT02='No execution: SumOfPortNumbers<10!! necessary.';
FT03=['Parameter access denied!' 10 10 'Pre-condition for changes is: '];
FT04='"Alternative power variable input" = off!';
FT05='KNA: Inconsistent +/- String before Dummy cancellation!';
FT06='KNA: Inconsistent Dummy existence!';

h=gcb;                                      %Handle des Subsystemes, da Callback
AB=str2double(get_param(h,'AB'));           %AB-Soll-Anzahl (CPP)
if strcmp(get_param(h,'UM'),'on'),          %Alternative Eingangsvariable:
              %Aenderungen erst nach Rckschaltung in "Normalbetrieb" zulassen
              %'UM'=='on' und Dummy=1 schlieen sich aus --> Minus unverfaelscht!!
   Sum=get_param([h '/S'],'Inputs'); Minus=length(findstr(Sum,'-'));
   FieldNames=fieldnames(get_param(h,'Dialogparameters')); % NodeBlockVersion ?
   if   sum(strcmp(FieldNames(:),'BI')), BI_str=get_param(h,'BI'); %Schon BI ?
   else                                  BI_str='off'; end %indirekt, da String
   if strcmp(BI_str,'on'), Minus=Minus+1; end
   if AB~=Minus, set_param(h,'AB',num2str(Minus)); %Rcksetzen von nderungen
                 errordlg([h 10 10 FT03 FT04],FT00); end;
   return;                                  %Keine nderung von CPP bei UM=='on'!
end
h2=gcs;
TYW=get_param(h,'TY');
if findstr(TYW,'1-'), BB1='E'; BB2='F'; else  BB1='F'; BB2='E'; end
x_str=get_param([h '/S'],'Inputs');         %Summe: '+/-' String
z=length(x_str);                            %Gesamt-Ist-Anzahl
x=length(findstr(x_str,'+'));               %ZU-Ist-Anzahl
y=z-x;                                %AB-Ist-Anzahl gegfalls um Dummy verfaelscht
if AB<0|rem(AB,1)~=0, errordlg([h 10 10 FT01],FT00); return; end %Eingabefehler?
if x+AB>9,            errordlg([h 10 10 FT02],FT00); return; end %Eingabefehler?
bln=get_param(h,'Name');                    %Block-Name des Subsystems
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                   'BlockType','Constant','Name','Dummy');%Sonderfall Durchschleifen?
if isempty(blks) Dummy=0; else Dummy=1; end %Merker; Dummy erhht x_str, z, y um '+1'
y=y-Dummy;                                  %Dummy auch an AB-Port, aber anderer Name
DV=AB-y; D=abs(DV);                         % y >=< AB ??

if D==0, return; end                %keine nderung unter Beruecksichtigung von Dummy

x_str='';                                  %Mischstelle: Anfangswert fr 'neu setzen'
for i=1:x, x_str(i)='+'; end; for i=1:AB, x_str(x+i)='-'; end; %x_str NEU

if y<AB                                      %Inports hinzufgen
   if  Dummy                                 %Dummy lschen; nun mehrere Sum-Eingnge
       if x+y~=1 errordlg([h 10 10 FT05],FT00); return; end %Fehler in anderer Fktn?
       delete_line( [h2 '/' bln] , ['Dummy/1'] , ['S/2'] ); %mu '2' sein!
       delete_block( [h '/Dummy' ] );
   end
   set_param([h '/S'], 'Inputs', x_str);     %Summe: '+/-' String
   for i=1:D                                 %From-Blcke  hinzufgen
       str_nr=char([48+z+i]);
       prt_nr=char([49+y+i]);                % 49 --> 1 OutPort fr '0'
       L=length(h); Pfad=h; for j=1:L, if Pfad(j)==47, Pfad(j)=95; end;end %'/'-->'_'
       N=[ Pfad str_nr];
       add_block( 'built-in/From', [h '/K' str_nr ], 'GotoTag', N );
       add_line( [h2 '/' bln] , ['K' str_nr '/1'], ['S/' str_nr] );
       add_block( 'built-in/Outport', [h '/' BB2 str_nr ], 'Port', prt_nr );
       add_line( [h2 '/' bln] , ['K0/1'], [ BB2 str_nr '/1'] );
   end
else                                         %Inports lschen, also mehrere vorhanden
   if  Dummy errordlg([h 10 10 FT06],FT00); return; end %Fehler in anderer Fktn?
   for i=1:D     %umgekehrte Reihenfolge!
       str_nr=char([49+z-i]);
       delete_line( [h2 '/' bln] , ['K0/1'], [BB2 str_nr '/1'] );
       delete_block( [h '/' BB2 str_nr ] );
       delete_line( [h2 '/' bln] , ['K' str_nr '/1'] , ['S/' str_nr]);
       delete_block( [h '/K' str_nr ] );
   end
   if  (x==1)&&(AB==0)                        %Dummy nun notwendig?
       x_str(x+AB+1)='-';                     %x+AB=1 ist gesichert
       add_block( 'built-in/Constant',[h '/Dummy' ],'Value','0');
       add_line( [h2 '/' bln] , ['Dummy/1'] , ['S/2'] ); %mu 2 sein: s.o.!
   end
   set_param([h '/S'], 'Inputs', x_str);%Summe: '+/-' String gegflls erhht fr Dummy
end
