function BGV2_KNT
%Erweiterungsbibliothek Bondgraph V.2 // KN - Element: Typ-Erkennung
%                                        1- / 0- Knoten
%Der entsprechende Kode wird in der Blockinitialisierung gesetzt

FT00='KN Element - BGV2_KNT';
FT01=['Parameter access denied!' 10 10 'Pre-condition for changes is: '];
FT02='"Alternative power variable input" = off!';

h=gcb;
TYW=get_param(h,'TY');
if strcmp(get_param(h,'UM'),'on'),         %Alternative Eingangsvariable:
                      %nderungen erst nach Rckschaltung in "Normalbetrieb" zulassen
   K=str2double(get_param([h '/K'],'Value'));
   if K==60||K==62, Type='0-Node'; else Type='1-Node'; end
   if ~strcmp(TYW,Type), set_param(h,'TY',Type);
                         errordlg([h 10 10 FT01 FT02],FT00); end; return;
end
S1=0;
ZU=str2double(get_param(h,'ZU'));
AB=str2double(get_param(h,'AB'));
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','BlockType','Outport');
if findstr(TYW,'1-')                        %1-Knoten: E0 berechnen
   N=find_system(blks,'name','E0');         %Ausgangsname?
   if isempty(N), set_param([h '/F0'],'name','E0');
   S1=1; Bez1='E'; Bez2='F';
   end
else                                        %0-Knoten: F0 berechnen
   N=find_system(blks,'name','F0');         %Ausgangsname?
   if isempty(N), set_param([h '/E0'],'name','F0');
   S1=1; Bez1='F'; Bez2='E';
   end
end
if S1
   for i=1:ZU
       N=num2str(i);
       set_param([h '/' Bez2 N],'name',[Bez1 N]), %wie fr X0
   end
   for i=1:AB
       N=num2str(i+ZU);                           %um 'ZU' verschieben
       set_param([h '/' Bez1 N],'name',[Bez2 N]), %umgekehrt zu X0
   end
end