function BGV2_KNZ
%Erweiterungsbibliothek Bondgeaph V.2 // KN - Element: zugefhrte Energie
%                                                      Portanzahl ZU >= 1

FT00='KN Element - BGV2_KNZ';
FT01='No execution: False "FPP" Input!';
FT02='No execution: SumOfPortNumbers<10!! necessary.';
FT03=['Parameter access denied!' 10 10 'Pre-condition for changes is: '];
FT04='"Alternative power variable input" = off!';
FT05='KNZ: Inconsistent +/- String before Dummy cancellation!';
FT06='KNZ: Inconsistent Dummy existence!';

h=gcb;                                      %Handle des Subsystemes, da Callback
ZU=str2double(get_param(h,'ZU'));           %ZU-Soll-Anzahl (FPP)
if strcmp(get_param(h,'UM'),'on'),          %Alternative Eingangsvariable:
                 %nderungen erst nach Rckschaltung in "Normalbetrieb" zulassen
   Sum=get_param([h '/S'],'Inputs'); Plus=length(findstr(Sum,'+'));
   FieldNames=fieldnames(get_param(h,'Dialogparameters')); % NodeBlockVersion ?
   if   sum(strcmp(FieldNames(:),'BI')), BI_str=get_param(h,'BI'); %Schon BI ?
   else                                  BI_str='off'; end %indirekt, da String
   if strcmp(BI_str,'on'), Plus=Plus-1; end
   if ZU~=Plus, set_param(h,'ZU',num2str(Plus)); %Rcksetzen von nderungen
                errordlg([h 10 10 FT03 FT04],FT00); end;
   return;                                  %Keine nderung von FPP bei UM=='on'!
end
h2=gcs;
TYW=get_param(h,'TY');
if findstr(TYW,'1-'), BB1='E'; BB2='F'; else  BB1='F'; BB2='E'; end
x_str=get_param([h '/S'],'Inputs');         %Summe: '+/-' String
z=length(x_str);                            %Gesamt-Ist-Anzahl
x=length(findstr(x_str,'+'));               %ZU-Ist-Anzahl
y=z-x;                                   %AB-Ist-Anzahl gegfalls um Dummy verfaelscht
if ZU<1|rem(ZU,1)~=0, errordlg([h 10 10 FT01],FT00); return; end %Eingabefehler?
if y+ZU>9,            errordlg([h 10 10 FT02],FT00); return; end %Eingabefehler?
bln=get_param(h,'Name');                    %Block-Name des Subsystems
DV=ZU-x; D=abs(DV);                         % x >=< ZU ??

if D==0, return; end                        %keine nderung

blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                   'BlockType','Constant','Name','Dummy');%Sonderfall Durchschleifen?
if isempty(blks) Dummy=0; else Dummy=1; end %Merker; Dummy erhht x_str, z, y um '+1'
y=y-Dummy;                                  %Dummy auch an AB-Port, aber anderer Name
for i=1:y                                   %alle AB-Ports zwischenzeitlich abtrennen
    str_nr=char([48+x+i]);                  %'48' --> 0 // x: ZU-Ist-Anzahl !!
    delete_line( [h2 '/' bln] , ['K' str_nr '/1'] , ['S/' str_nr] );
end

x_str='';                                   %Mischstelle:Anfangswert fr 'neu setzen'
for i=1:ZU, x_str(i)='+'; end; for i=1:y, x_str(i+ZU)='-'; end; %x_str NEU ohne Dummy

if x<ZU                                      %Inports hinzufgen
   if  Dummy                                 %Dummy lschen; nun mehrere Sum-Eingnge
       if x+y~=1 errordlg([h 10 10 FT05],FT00); return; end %Fehler in anderer Fktn?
       delete_line( [h2 '/' bln] , ['Dummy/1'] , ['S/2'] ); %mu '2' sein!
       delete_block( [h '/Dummy' ] );
   end
   set_param([h '/S'], 'Inputs', x_str);     %Summe: '+/-' String neu
   for i=1:D                                 %Delta Inports  hinzufgen
       str_nr=char([48+x+i]);
       add_block( 'built-in/Inport', [h '/' BB1 str_nr ], 'Port', str_nr );
       add_line( [h2 '/' bln] , [BB1 str_nr '/1'], ['S/' str_nr] );
   end

else                                         %Inports lschen, also mehrere vorhanden
   if  Dummy errordlg([h 10 10 FT06],FT00); return; end %Fehler in anderer Fktn?
   for i=1:D     %umgekehrte Reihenfolge!
       str_nr=char([49+x-i]);
       delete_line( [h2 '/' bln] , [BB1 str_nr '/1'], ['S/' str_nr] );
       delete_block( [h '/' BB1 str_nr ] );
       %Erst Goto-Blcke lschen und damit Namen fr AB Ports freigeben
       delete_line( [h2 '/' bln] , ['K0/1'] , ['K' str_nr '/1']);
       delete_block( [h '/K' str_nr ] );
   end
   if  (ZU==1)&&(y==0)                       %Dummy nun notwendig?
       x_str(ZU+y+1)='-';                    %ZU+y=1 ist gesichert
       add_block( 'built-in/Constant',[h '/Dummy' ],'Value','0');
       add_line( [h2 '/' bln] , ['Dummy/1'] , ['S/2'] ); %mu 2 sein: s.o.!
   end
   set_param([h '/S'], 'Inputs', x_str);  %Sum: '+/-' String gegflls erhht fr Dummy
end

for j=1:y         %alle AB-Ports wieder anschlieen; entfllt bei y=0 <---> Dummy!
    if   x<ZU
         i=y+1-j; %Keine zwischenzeitliche Namensdopplung --> umgekehrte Reihenfolge!
    else i=j; end
    str_nr=char([48+x+i]); EPN_neu=char([48+x+i+DV]);      %und vorher umbenennen:
    set_param( [h '/K' str_nr] , 'name' , ['K' EPN_neu]) %AB-FROM
    set_param( [h '/' BB2 str_nr] , 'name' , [BB2 EPN_neu]) %AB-Outport
    add_line( [h2 '/' bln] , ['K' EPN_neu '/1'] , ['S/' EPN_neu] );
    %Folgende zwei Zeilen sind nicht notwendig, da GotoTag's bei Anlauf manipuliert
    N=get_param( [h '/K' EPN_neu], 'GotoTag'); N(end)=EPN_neu;
    set_param( [h '/K' EPN_neu], 'GotoTag', N );
end

if x<ZU     %Namen sind jetzt erst durch AB Ports freigegeben, Goto-Blcke hinzufgen
   for i=1:D
       str_nr=char([48+x+i]);
       L=length(h); Pfad=h; for j=1:L, if Pfad(j)==47, Pfad(j)=95; end;end %'/'-->'_'
       N=[ Pfad str_nr];
   add_block( 'built-in/Goto',[h '/K' str_nr ],'GotoTag',N,'TagVisibility','global');
       add_line( [h2 '/' bln] , ['K0/1'] , ['K' str_nr '/1']);
   end
end