function BGV2_SD
%Anpassung von Block Source / Destination an
%ausgewhlten Block-Type: Source oder Destination
%                         Effort oder Flow Vorgabe
%Der entsprechende Kode wird in der Block-Initialisierung [BGV2_Init(10)] gesetzt

h=gcb; TYW=get_param(h,'TY');
if findstr(TYW,'Source') SD=1;           else SD=0;           end; %Alt.: Destination
if findstr(TYW,'Effort') EF=1; ZiBe='E'; else EF=0; ZiBe='F'; end; %Alternative: Flow
if SD                                                              %Source-->E/F
   if ~isempty(find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                                'BlockType','From'));
 blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','BlockType','Outport');
	  if      EF   N=find_system(blks,'name','E');
                   if isempty(N) set_param([h '/F'],'name','E'); end
	  else         N=find_system(blks,'name','F');
                   if isempty(N) set_param([h '/E'],'name','F'); end; end
   else                                               %Destination --> Source --> E/F
	   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                               'BlockType','Inport');
	   if ~isempty(find_system(blks,'name','E')) IsBe='E'; else IsBe='F'; end
	   replace_block(h,'FollowLinks','on','name',IsBe,'built-in/From','noprompt');
       set_param([h '/' IsBe],'name','U');
	   replace_block(h,'FollowLinks','on','name','I','built-in/Outport','noprompt');
       set_param([h '/I'],'Port','1');
	   set_param([h '/I'],'name',ZiBe);
       set_param([h '/U'],'name','I'); L=length(h); Pfad=h;
	   for i=1:L if Pfad(i)==47 Pfad(i)=95; end; end; 
       set_param([h '/I'],'GotoTag',Pfad);
   end
else                                                               %Dest.-->E/F
   if ~isempty(find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                                'BlockType','Goto'));
  blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','BlockType','Inport');
	   if      EF   N=find_system(blks,'name','E');
                    if isempty(N) set_param([h '/F'],'name','E'); end
	   else         N=find_system(blks,'name','F');
                    if isempty(N) set_param([h '/E'],'name','F'); end; end
   else                                              %Source --> Destionation --> E/F
	   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                              'BlockType','Outport');
	   if ~isempty(find_system(blks,'name','E')) IsBe='E'; else IsBe='F'; end
	   replace_block(h,'FollowLinks','on','name',IsBe,'built-in/Goto','noprompt'); 
       set_param([h '/' IsBe],'name','U');
	   replace_block(h,'FollowLinks','on','name','I','built-in/Inport','noprompt');
	   set_param([h '/I'],'name',ZiBe);
       set_param([h '/U'],'name','I'); L=length(h); Pfad=h;
	   for i=1:L if Pfad(i)==47 Pfad(i)=95; end; end;
	   set_param([h '/I'],'GotoTag',Pfad); 
       set_param([h '/I'],'TagVisibility','global');
    end
end

if   strcmp(get_param(h,'Ex'),'on'),      %Variabler Wert durch Externe Einspeisung
     blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                               'BlockType','Inport');
     N=find_system(blks,'name','S');      %Externe Einspeisung schon eingestellt?
     if  isempty(N)                       %Nein: Einstellung ndern
         replace_block(h,'FollowLinks','on','name','S','built-in/Inport','noprompt');
         set_param([h '/S'],'Port','1');
     end
else                                      %Konstanter Wert durch Interne Eingabe
     blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                             'BlockType','Constant');
     N=find_system(blks,'name','S');      %Interne Vorgabe schon eingestellt?
     if  isempty(N)                       %Nein: Einstellung ndern
         replace_block(h,'FollowLinks','on','name','S',...
                                                     'built-in/Constant','noprompt');
         set_param([h '/S'],'Value','VA');
     end
end
