function BGV2_SDE
%Zu- bzw. Abschaltung eines IC-Blocks in Block Source / Destination

h=gcb;
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                     'BlockType','InitialCondition');
if isempty(find_system(blks,'Name','IC')),
   BLI=0; else BLI=1; end                 %Block von IC-Typ vorhanden?
MPI=strcmp(get_param(h,'IC'),'on');       %MaskenParameter "IC" gesetzt?
if (MPI&~BLI)|(BLI&~MPI)                  %nderung gefordert?
   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                     'BlockType','Inport');
   if isempty(find_system(blks,'Name','S')), %Inport namens "S" vorhanden? (Pnr==1!)
      IPS=0; else IPS=1; end
   h2=gcs;
   bln=get_param(h,'Name');               %Block-Name des Subsystems
   if   MPI&~BLI                          %IC-Block neu einfgen
        replace_block(h,'FollowLinks','on','Name','S',...
                                             'built-in/InitialCondition','noprompt');
        set_param([h '/S'],'Name','IC','Value','0');  %Name==IC und AW==0
        if   IPS                          %Eingang war Inport-Block
             add_block('built-in/Inport', [h '/S'],'Port','1'); %Nummer fest, vgl. SD
        else                              %Eingang war Constant-Block
             add_block('built-in/Constant', [h '/S'],'Value','VA'); %VA aus BlockMask
        end
        add_line( [h2 '/' bln] ,'S/1','IC/1');
   else                                   %IC-Block lschen
        delete_line( [h2 '/' bln] ,'S/1','IC/1');
        delete_block([h '/S']);
        if   IPS                          %Eingang war Inport-Block
             replace_block(h,'FollowLinks','on','Name','IC',...
                                             'built-in/Inport','noprompt');
             set_param([h '/IC'],'Name','S','Port','1');
        else                              %Eingang war Constant-Block
             replace_block(h,'FollowLinks','on','Name','IC',...
                                             'built-in/Constant','noprompt');
             set_param([h '/IC'],'Name','S','Value','VA');
        end
   end
end
