function BGV2_TFN
%TF / GY : Umschaltung linear / nicht-linear

FT01='False Type-Code detected';
FT02='False ZV-Code detected';
FT03='False AV-Code detected';

h=gcb;
load_system('BG_V20_TS');    %vorsorglich fr Fall "skalar - reziprocal"
AV=0;                        %Ausgangsvariante AV nach S.113
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','Name','UKB');
if  isempty(blks) AV=1; else AV=3; end
blks=find_system(h,'FollowLinks','on','LookUnderMasks','all','Name','TP');
if  ~isempty(blks) AV=AV+1; end %AV = {1,2,3,4} nach S.113
ZV=0;                        %Zielvariante nach S.113
Mode=get_param(h,'MU');      %Mode = {Scalar, Vector, Matrix}
if     findstr(Mode,'Vector') ZV=2; else ZV=1; end
TY=get_param(h,'TY');        %Type = {Left,Right,Outside,Inside}
if     findstr(TY,'Left')    BG_Ein='F1'; 
elseif findstr(TY,'Right')   BG_Ein='E1'; ZV=ZV+2; %Init-Umkehr!
elseif findstr(TY,'Outside') BG_Ein='F';
elseif findstr(TY,'Inside')  BG_Ein='E';  ZV=ZV+2; %Init Umkehr!
else   error(FT01); end      %ZV = {1,2,3,4} Zielvariante ZV nach S.113
SK=AV*10+ZV;                 %Switch Kode SK

if strcmp(get_param(h,'NL'),'on')       %Verstrkung nun nicht-linear eingestellt?
 blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                           'BlockType','Product');
   if isempty(blks)                     %Vorzustand: linear [linear --> NL]
      delete_line(h,[BG_Ein '/1'],'GR/1');    delete_line(h, 'I2/1','GL/1');
    replace_block(h,'FollowLinks','on','name','GR','built-in/Product','noprompt');
    replace_block(h,'FollowLinks','on','name','GL','built-in/Product','noprompt');
      set_param([h '/GR'],'Multiplication','Matrix(*)');
      set_param([h '/GL'],'Multiplication','Matrix(*)');
      add_line(h,[BG_Ein '/1'],'GR/2');       add_line(h,'I2/1','GL/2');
      add_block('built-in/Inport',[h '/NL']); %nur 1 mal fr beide Richtungen!
      if  ZV==3|ZV==4                         %Init-Umkehr? --> UKB einfgen
          if     findstr(Mode,'Scalar')
                 add_block('BG_V20_TS/UKB',[h '/UKB']);        %Skalar
          elseif findstr(Mode,'Vector')
                 add_block('built-in/Math',[h '/UKB']);        %Vektor
                 set_param([h '/UKB'],'Operator','transpose')
          else   add_block('built-in/MATLABFcn',[h '/UKB']);   %Matrix
                 set_param([h '/UKB'],'MATLABFcn','inv(u)')
          end; end
      if  ZV==2|ZV==4                         %VektorMode? --> TP einfgen
          add_block('built-in/Math',[h '/TP']);
          set_param([h '/TP'],'Operator','transpose')
      end
      switch ZV
          case {1}, add_line(h,'NL/1','GR/1');  add_line(h,'NL/1','GL/1');
          case {2}, add_line(h,'NL/1','GR/1');
                    add_line(h,'NL/1','TP/1');  add_line(h,'TP/1','GL/1');
          case {3}, add_line(h,'NL/1','UKB/1');
                    add_line(h,'UKB/1','GR/1'); add_line(h,'UKB/1','GL/1');
          case {4}, add_line(h,'NL/1','UKB/1'); add_line(h,'UKB/1','TP/1');
                    add_line(h,'UKB/1','GR/1'); add_line(h,'TP/1','GL/1');
        otherwise,  error(FT02);
      end
   else                                     %Vorzustand nicht-linear! [NL --> NL]
      if     findstr(Mode,'Scalar') %Skalar
             BloPar='Operator'; BloVal='reciprocal';  %Auswertung in Fkt Einfgen
      elseif findstr(Mode,'Vector') %Vektor
             BloPar='Operator'; BloVal='transpose';    
      else                          %Matrix
             BloPar='MATLABFcn'; BloVal='inv(u)';
      end
      Oeffnen(h,SK);
      Loeschen(h,SK);
      Einfuegen(h,SK,BloPar,BloVal);
      Verbinden(h,SK);
   end
else                        %Nein: Verstrkung linear eingestellt! [NL --> linear]
   blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                      'BlockType','Gain','Name','GL');%TFI == 'VZN' ausschlieen!
   if isempty(blks)                                  %ntig bei ffnung Maskenmen
      switch AV
          case {1}, delete_line(h,'NL/1','GR/1');  % weder UKB noch TP vorhanden
                    delete_line(h,'NL/1','GL/1');
          case {2}, delete_line(h,'NL/1','GR/1');  % nur TP vorhanden
                    delete_line(h,'NL/1','TP/1'); delete_line(h,'TP/1','GL/1');
                    delete_block([h '/TP']);
          case {3}, delete_line(h,'NL/1','UKB/1'); % nur UKB vorhanden
                    delete_line(h,'UKB/1','GR/1'); delete_line(h,'UKB/1','GL/1');
                    delete_block([h '/UKB']);
          case {4}, delete_line(h,'NL/1','UKB/1'); % Blcke UKB und TP vorhanden
                    delete_line(h,'UKB/1','GR/1'); delete_line(h,'UKB/1','TP/1');
                    delete_line(h,'TP/1','GL/1');
                    delete_block([h '/UKB']); delete_block([h '/TP']);
          otherwise, error(FT03);
      end
      delete_block([h '/NL']);                %nur 1 mal !
      delete_line(h,[BG_Ein '/1'],'GR/2');    delete_line(h,'I2/1','GL/2');
      replace_block(h,'FollowLinks','on','name','GR','built-in/Gain','noprompt');
      replace_block(h,'FollowLinks','on','name','GL','built-in/Gain','noprompt');
      set_param([h '/GR'],'Gain','VA');       set_param([h '/GL'],'Gain','VA');
      set_param([h '/GR'],'Multiplication','Matrix(K*u) (u vector)');
      set_param([h '/GL'],'Multiplication','Matrix(K*u) (u vector)');
      add_line(h,[BG_Ein '/1'],'GR/1');       add_line(h,'I2/1','GL/1');
   end
   BGV2_TFV %VA [GL / GR] kausalitaets-abhaengig mode-unabhaengig transponieren
end

function Oeffnen(h,SK)
switch SK
       case {14,13}, delete_line(h,'NL/1','GR/1'); %1 komplett oeffnen
                     delete_line(h,'NL/1','GL/1');
       case {23},    delete_line(h,'NL/1','GR/1'); %2 komplett oeffnen
                     delete_line(h,'NL/1','TP/1');
                     delete_line(h,'TP/1','GL/1');
       case {31,32}, delete_line(h,'NL/1','UKB/1');%3 komplett oeffnen
                     delete_line(h,'UKB/1','GR/1');
                     delete_line(h,'UKB/1','GL/1');
       case {41},    delete_line(h,'NL/1','UKB/1');%4 komplett oeffnen
                     delete_line(h,'UKB/1','GR/1');
                     delete_line(h,'UKB/1','TP/1');
                     delete_line(h,'TP/1','GL/1');
       case {12},    delete_line(h,'NL/1','GL/1'); %1 nur NL/GL oeffnen
       case {21},    delete_line(h,'NL/1','TP/1'); %2 nur NL/TP + TP/GL oeffnen
                     delete_line(h,'TP/1','GL/1');
       case {24},    delete_line(h,'NL/1','GR/1'); %2 ohne TP/GL oeffnen
                     delete_line(h,'NL/1','TP/1');
       case {34},    delete_line(h,'UKB/1','GL/1');%3 nur UKB/GL oeffnen
       case {42},    delete_line(h,'NL/1','UKB/1');%4 ohne TP/GL oeffnen
                     delete_line(h,'UKB/1','GR/1');
                     delete_line(h,'UKB/1','TP/1');
       case {43},    delete_line(h,'UKB/1','TP/1');%4 nur UKB/TP + TP/GL oeffenen
                     delete_line(h,'TP/1','GL/1');
       case {11,22,33,44},                         %keine Aenderung
    otherwise, error(FT02);
end
function Loeschen(h,SK)
switch SK
       case {23,43,21},      delete_block([h '/TP']);  %TP loeschen
       case {32,42,31},      delete_block([h '/UKB']); %UKB loeschen
       case {41},            delete_block([h '/TP']);  %TP + UKB loeschen
                             delete_block([h '/UKB']);
       case {14,24,34,13,12},                          %NICHTS loeschen
       case {11,22,33,44},                             %keine Aenderung
    otherwise, error(FT02);
end
function Einfuegen(h,SK,BloPar,BloVal)
MNR=1;                                                    %Merker nichtreziprocal
if   BloPar(1)=='O'
     if   BloVal(1)=='t' BloTyp='built-in/Math';          %alt fr transpose
     else                BloTyp='BG_V20_TS/UKB'; MNR=0;   %Merker nichtreziprocal
     end                                                  %neu fr skalar
else                     BloTyp='built-in/MATLABFcn'; end %alt fr matrix
switch SK
       case {14},            add_block(BloTyp,[h '/UKB']);        %UKB+TP einfgn
                             add_block(BloTyp,[h '/TP']);
                             set_param([h '/UKB'],BloPar,BloVal);
                             set_param([h '/TP'],BloPar,BloVal);
       case {24,13,23},      add_block(BloTyp,[h '/UKB']);        %nur UKB einfgn
                             if  MNR set_param([h '/UKB'],BloPar,BloVal); end
       case {12,32},         add_block(BloTyp,[h '/TP']);         %nur TP einfgn
                             set_param([h '/TP'],BloPar,BloVal);
       case {34},                                     % Skalar / Matrix --> Vektor
               replace_block(h,'FollowLinks','on','name','UKB',BloTyp,'noprompt');
                             set_param([h '/UKB'],BloPar,BloVal); %VektorMode!
                             add_block(BloTyp,[h '/TP']);         %nur TP einfgn
                             set_param([h '/TP'],BloPar,BloVal);
       case {43},                                     % Vektor --> Skalar / Matrix
               replace_block(h,'FollowLinks','on','name','UKB',BloTyp,'noprompt');
                             if MNR set_param([h '/UKB'],BloPar,BloVal); end
       case {42,21,31,41},                                        %NICHTS einfgn
       case {33}                                      % Skalar <--> Matrix
            blks=find_system(h,'FollowLinks','on','LookUnderMasks','all',...
                                                         'BlockType','MATLABFcn');
           if (isempty(blks)&BloPar(1)=='M')|(~isempty(blks)&BloPar(1)=='O')
                                   %nur bei: Matrix --> Skalar / Skalar --> Matrix
           replace_block(h,'FollowLinks','on','name','UKB',BloTyp,'noprompt'); end
                             if MNR set_param([h '/UKB'],BloPar,BloVal); end
            
       case {11,22,44},                                           %keine Aenderng
    otherwise, error(FT02);
end
function Verbinden(h,SK)
switch SK
       case {31,41}, add_line(h,'NL/1','GR/1'); %1 komplett verbinden
                     add_line(h,'NL/1','GL/1');
       case {32},    add_line(h,'NL/1','GR/1'); %2 komplett verbinden
                     add_line(h,'NL/1','TP/1');
                     add_line(h,'TP/1','GL/1');
       case {13,23}, add_line(h,'NL/1','UKB/1');%3 komplett verbinden
                     add_line(h,'UKB/1','GR/1');
                     add_line(h,'UKB/1','GL/1');
       case {14},    add_line(h,'NL/1','UKB/1');%4 komplett verbinden
                     add_line(h,'UKB/1','GR/1');
                     add_line(h,'UKB/1','TP/1');
                     add_line(h,'TP/1','GL/1');
       case {21},    add_line(h,'NL/1','GL/1'); %1 nur NL/GL verbinden
       case {42},    add_line(h,'NL/1','GR/1'); %2 nur NL/GR + NL/TP verbinden
                     add_line(h,'NL/1','TP/1');
       case {12},    add_line(h,'NL/1','TP/1'); %2 nur NL/TP + TP/GL verbinden
                     add_line(h,'TP/1','GL/1');
       case {43},    add_line(h,'UKB/1','GL/1');%3 nur UKB/GL verbinden
       case {34},    add_line(h,'UKB/1','TP/1');%4 nur UKB/TP + TP/GL verbinden
                     add_line(h,'TP/1','GL/1');
       case {24},    add_line(h,'NL/1','UKB/1');%4 ohne TP/GL verbinden
                     add_line(h,'UKB/1','GR/1');
                     add_line(h,'UKB/1','TP/1');
       case {11,22,33,44},                      %keine Aenderung
    otherwise, error(FT02);
end
